# This can't work in developer mode at the moment as the image hardcodes lbapi.app.cern.ch as the API URL
kind: Deployment
apiVersion: apps/v1
metadata:
  name: {{ include "lbap.fullname" . }}-lbapweb
  labels:
    {{- include "lbap.labels" . | nindent 4 }}
spec:
  replicas: {{ ternary 1 2 .Values.developer.enabled }}
  selector:
    matchLabels:
      {{- include "lbap.selectorLabels" . | nindent 6 }}
      app: lbapweb
  template:
    metadata:
      annotations:
        {{- with .Values.podAnnotations }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
      labels:
        {{- include "lbap.selectorLabels" . | nindent 8 }}
        app: lbapweb
    spec:
{{- if .Values.developer.enabled }}

      volumes:
        - name: lbap-code-mount
          persistentVolumeClaim:
            claimName: pvc-lbap-code
{{- end }}
      containers:
        - name: lbapweb
          resources:
            {{- toYaml .Values.lbapweb.resources | nindent 12 }}
{{- if .Values.developer.enabled }}
          image: >-
            node:latest
          args:
            - "sh"
            - "-c"
            # Use apt to install build dependencies as node-canvas doesn't have arm binaries
            # See https://github.com/Automattic/node-canvas/issues/1662
            - "apt update && apt install -y build-essential libcairo2-dev libpango1.0-dev libjpeg-dev libgif-dev librsvg2-dev && npm install && npm run dev -- -p 8080"
          workingDir: /code/LbAPWeb
          volumeMounts:
            - mountPath: /code/LbAPWeb
              subPath: LbAPWeb
              name: lbap-code-mount
              readOnly: false
{{- else }}
          image: {{ .Values.lbapweb.image }}
{{- end }}
          ports:
            - containerPort: 8080
              protocol: TCP
---
kind: Service
apiVersion: v1
metadata:
  name: {{ include "lbap.fullname" . }}-lbapweb
  labels:
    {{- include "lbap.labels" . | nindent 4 }}
spec:
  ports:
    - name: lbapweb
      port: 8080
      protocol: TCP
      targetPort: 8080
{{- if .Values.developer.enabled }}
      nodePort: 32500
  type: NodePort
{{- else }}
  type: ClusterIP
{{- end }}
  selector:
    {{- include "lbap.selectorLabels" . | nindent 4 }}
    app: lbapweb
